// rshd.c
// ------
// A simpleminded implementation of RSHD on under NT. No user-level security at all. Fuck it.
// (C) Pison Ltd., 1999

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <io.h>
#include <process.h>
#include <time.h>

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <winsock.h>

#include "config.h"
#include "regexp.h"

#define SHELL_PORT		(514)
#define RUN_CMD			""				// Should we change it to %COMSPEC% /C ? (Slow?)

typedef struct {
	BOOL	debug;
	BOOL	checkAll;
	Config	cfg;
} Options;

typedef struct {
	SOCKET	s;
	Options	*opts;
} CmdData;

static LPSTR addStr(LPSTR str, LPSTR add)
{
	int		len = (str)?(strlen(str)):(0);
	str = realloc(str, len + strlen(add) + 1);
	str[len] = '\0';
	strcat(str, add);
	return str;
}

static LPSTR addChr(LPSTR str, char add)
{
	int		len = (str)?(strlen(str)):(0);
	str = realloc(str, len + 2);
	str[len + 1] = '\0';
	str[len] = add;
	return str;
}

static BOOL pathSubOne(char **str, regexp *rx, char *to, char **next)
{
	char	*ptr, *tmp, *nstr;
	int		len;

	if(!regexec(rx, (*next)))
		return FALSE;

	nstr = (char *)malloc(strlen(*str) - (rx->endp[0] - rx->startp[0]) + strlen(to) + 2);
	
	len = ((*str) - rx->endp[0]) + strlen(*str);
	
	// Copy the part before the found item
	ptr = rx->startp[0];
	tmp = (*str);
	
	nstr[0] = '\0';
	if(rx->startp[0] != (*str))
		strncat(nstr, (*str), rx->startp[0] - (*str));
	
	strcat(nstr, to);
	
	*next = nstr + strlen(nstr);

	if(len)
		strcat(nstr, rx->endp[0]);
	free(*str);
	*str = nstr;
	return TRUE;
}

static LPSTR pathSubMany(LPSTR str, LPSTR from, LPSTR to)
{
	LPSTR	mstr = strdup(str);
	char	*next;
	regexp	*rx;
	
	rx = regcomp(from);
	if(!rx)
		return mstr;
	
	next = mstr;
	while(pathSubOne(&mstr, rx, to, &next))
		;
	return mstr;
}

static LPSTR doPathSubst(LPSTR str, Config *cfg)
{
	LPSTR	res = NULL;
	LPSTR	mstr = strdup(str);
	int		i;
	
	if(!cfg->noTrans)
		return strdup(str);

	for(i = 0; i < cfg->noTrans; i++) {
		LPSTR	tmp;

		tmp = pathSubMany(mstr, cfg->trfrom[i], cfg->trto[0]);
		free(mstr);
		mstr = tmp;
	}
	return mstr;
}

static LPSTR doEnvSubst(LPSTR str)
{
	LPSTR	a;
	LPSTR	res = NULL;
	
	for(a = str; *a; a++) {
		if(*a == '%') {
			char	*b;
			
			if(a[1] == '%' || a[1] == '\0') {
				res = addChr(res, '%');
				a++;
				if(a[1] == '\0')
					return res;
				continue;
			}

			for(b = a + 1; *b && *b != '%'; b++)
				;
			
			if(*b == '%') {
				char	s, *env;
				int		len;

				s = b[0];
				b[0] = '\0';
				
				len = GetEnvironmentVariable(a + 1, NULL, 0);
				if(len != 0) {
					env = malloc(len);
					GetEnvironmentVariable(a + 1, env, len);
					res = addStr(res, env);
					free(env);
				}
				b[0] = s;
				a = b;
			} else {
				char	s;
				s = b[1];
				b[1] = '\0';
				res = addStr(res, a);
				b[1] = s;
				a = b + 1;
			}
		} else
			res = addChr(res, *a);
	}
	return res;
}

static char *getCommandName(char *cmdStr)
{
	char	*cmd = NULL;
	
	while(*cmdStr && isspace(*cmdStr))
		cmdStr++;

	if(*cmdStr == '\"')
		cmdStr++;

	while(*cmdStr && (isalnum(*cmdStr) || *cmdStr == '.' || *cmdStr == '_'))
		cmd = addChr(cmd, *cmdStr++);

	if(!strchr(cmd, '.'))
		cmd = addStr(cmd, ".exe");

	return cmd;
}

// Create a socket and bind it to an unused, reserved port

// XXX:  THIS DOES NOT WORK PROPERLY. IF A PORT IS USED TWICE IN A ROW
//       IT WILL FAIL THE SECOND TIME. BIND() IS NOT WORKING AS SHOULD
//       So we've resorted to shotgun methods at the moment.

static SOCKET rresvport(int *alport)
{
	SOCKADDR_IN		sin;
	SOCKET			s;
	BOOL			off = FALSE, on = TRUE;
	
	ZeroMemory(&sin, sizeof(sin));
	sin.sin_family = AF_INET;
	sin.sin_addr.s_addr = INADDR_ANY;
	s = socket(AF_INET, SOCK_STREAM, 0);

	if(s == INVALID_SOCKET)
		return s;

	if(setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (char *)&on, sizeof(on)) == SOCKET_ERROR) {
		closesocket(s);
		return INVALID_SOCKET;
	}
	
	if(setsockopt(s, SOL_SOCKET, SO_DONTLINGER, (char *)&off, sizeof(off)) == SOCKET_ERROR) {
		closesocket(s);
		return INVALID_SOCKET;
	}

	for(;;) {
		sin.sin_port = htons((u_short)*alport);
		if(bind(s, (SOCKADDR *)&sin, sizeof(sin)) == 0) {
			return s;
		}
		if(GetLastError() != WSAEADDRINUSE) {
			closesocket(s);
			break;
		}

		(*alport)--;
		if(*alport == IPPORT_RESERVED / 2) {
			(void)closesocket(s);
			break;
		}
	}
	return INVALID_SOCKET;
}

static BOOL getStr(SOCKET s, char *buf, int max)
{
	DWORD	noRead;
	char	c;

	do {
		if(!ReadFile((HANDLE)s, &c, 1, &noRead, NULL) || noRead != 1)
			return FALSE;

		*buf++ = c;
		if(--max == 0)
			return FALSE;
	} while(c != 0);

	return TRUE;
}

static DWORD WINAPI cmdThread(LPDWORD data)
{
	SOCKADDR_IN	sin, psin;
	STARTUPINFO	si;
	PROCESS_INFORMATION	pi;
	CmdData		*cd = (CmdData *)data;
	BOOL		on = TRUE;
	DWORD		ti, noWrite;
	WORD		port;
	SOCKET		ctrls, datas;
	Options		*opts;
	char		remuser[16], locuser[16], cmd[4096], *tmpstr = NULL, *cmdstr = NULL;
	int			sinLen, nport;
	
	ctrls = cd->s;
	opts = cd->opts;
	ti = GetCurrentThreadId();
	
	if(opts->debug)
		fprintf(stderr, "DEBUG: [%d] Command thread started...\n", ti);
	
	

	// Grab the port number

	port = 0;
	
	for(;;) {
		DWORD	noRead;
		char	c;

		if(!ReadFile((HANDLE)ctrls, &c, 1, &noRead, NULL) || noRead != 1) {
			fprintf(stderr, "ERROR: Failed to read port number.\n");
			goto error2;
		}
		if(c == '\0')
			break;

		port = port * 10 + c - '0';
	}

	if(opts->debug)
		fprintf(stderr, "DEBUG: [%d] Got port number %d\n", ti, port);
	
	// Get a reserved port to connect to 
	
	srand(time(NULL));
	nport = rand() % 511 + 513;
	datas = rresvport(&nport);

	if(datas == INVALID_SOCKET) {
		fprintf(stderr, "ERROR: Got an invalid socket. (Error Code = %d)\n", WSAGetLastError());
		goto error;
	}
	
	// .. and connect to it.
	
	sinLen = sizeof(sin);

	if(getpeername(ctrls, (SOCKADDR *)&sin, &sinLen) == SOCKET_ERROR) {
		fprintf(stderr, "ERROR: Can't get peer name (Error Code = %d)\n", WSAGetLastError());
		goto error;
	}
	sin.sin_family = AF_INET;
	sin.sin_port = htons(port);
	
	if(opts->debug)
		fprintf(stderr, "DEBUG: [%d] Connecting to the stderr socket (from port %d)...\n", ti, nport);

	if(connect(datas, (SOCKADDR *)&sin, sizeof(sin)) == SOCKET_ERROR) {
		fprintf(stderr, "ERROR: Can't connect data stream to remote port (Error Code = %d).\n", WSAGetLastError());
		goto error;
	}
	
	// Get the remote user, local user and command to execute

	if(!getStr(ctrls, remuser, sizeof(remuser))) {
		fprintf(stderr, "ERROR: Remote user name too long.\n");
		goto error;
	}
	if(!getStr(ctrls, locuser, sizeof(locuser))) {
		fprintf(stderr, "ERROR: Local user name too long.\n");
		goto error;
	}
	if(!getStr(ctrls, cmd, sizeof(cmd))) {
		fprintf(stderr, "ERROR: Command line too long.\n");
		goto error;
	}

	if(opts->debug) {
		fprintf(stderr, "DEBUG: [%d] Remote user name: '%s'\n", ti, remuser);
		fprintf(stderr, "DEBUG: [%d] Local user name: '%s'\n", ti, locuser);
		fprintf(stderr, "DEBUG: [%d] Command line: '%s'\n", ti, cmd);
	}
	
		// Get the peer's IP and see if we can server it.

	if(opts->cfg.noAIP) {
		unsigned long	pip;
		BOOL			veto;
		int				psize = sizeof(psin), i;
		
		psize = sizeof(psin);
		if(getpeername(ctrls, (SOCKADDR *)&psin, &psize)) {
			fprintf(stderr, "getpeername() failed.\n");
			goto error2;
		}
		pip = ntohl(psin.sin_addr.s_addr);
		veto = FALSE;
		for(i = 0; i < opts->cfg.noAIP; i++) {
			AllowIP		*aip = &opts->cfg.aip[i];

			if((pip & aip->mask) == aip->ip)
				veto = TRUE;
		}
		if(!veto) {
			fprintf(stderr, "WARNING: Incoming connection from %d.%d.%d.%d rejected.\n",
				(pip >> 24) & 0xFF, (pip >> 16) & 0xFF, (pip >> 8) & 0xFF, (pip) & 0xFF);
			
			WriteFile((HANDLE)ctrls, "XConnection rejected\n", 21, &noWrite, NULL);
			goto error2;
		}
	}

	// Acknowledge connection...
	if(!WriteFile((HANDLE)ctrls, "\0", 1, &noWrite, NULL) || noWrite != 1) {
		fprintf(stderr, "ERROR: Couldn't send ACK byte.\n");
		goto error;
	}

	// Do environment variable substitution...
	
	tmpstr = doEnvSubst(cmd);

	// ..and regexp substitutions...
	
	cmdstr = doPathSubst(tmpstr, &opts->cfg);

	free(tmpstr);

	// ..and kick off!
	{
		unsigned long	pip;
		int				psize = sizeof(psin);
		struct hostent	*hent;
		getpeername(ctrls, (SOCKADDR *)&psin, &psize);
		pip = ntohl(psin.sin_addr.s_addr);
		hent = gethostbyaddr((unsigned char *)&psin.sin_addr.s_addr, sizeof(psin.sin_addr.s_addr), AF_INET);
		if(hent == NULL)
			fprintf(stderr, "INFO: Executing '%s' from %d.%d.%d.%d (Unknown).\n", 
				getCommandName(cmdstr),
				(pip >> 24) & 0xFF, (pip >> 16) & 0xFF, (pip >> 8) & 0xFF, (pip) & 0xFF);
		else
			fprintf(stderr, "INFO: Executing '%s' from %s (%d.%d.%d.%d)\n", 
				getCommandName(cmdstr), hent->h_name,
				(pip >> 24) & 0xFF, (pip >> 16) & 0xFF, (pip >> 8) & 0xFF, (pip) & 0xFF);
		
	}

	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);
	si.hStdInput = (HANDLE)ctrls;
	si.hStdOutput = (HANDLE)ctrls;
	si.hStdError = (HANDLE)datas;
	si.dwFlags = STARTF_USESTDHANDLES;
	
	if(opts->debug)
		fprintf(stderr, "DEBUG: [%d] Command line used: '%s'\n", ti, cmdstr);

	if(!CreateProcess(NULL, cmdstr, NULL, NULL, TRUE, 0, NULL, NULL, &si, &pi)) {
		WriteFile((HANDLE)ctrls, "\001Couldn't execute command\n", 26, &noWrite, NULL);
		fprintf(stderr, "ERROR: Couldn't start command. (Error Code = %08x)\n", ti, GetLastError());
		goto error;
	}

	// Wait until thread is terminated
	
	for(;;) {
		DWORD	ec;

		Sleep(0);
		if(!GetExitCodeProcess(pi.hProcess, &ec))
			break;

		if(ec != STILL_ACTIVE)
			break;
	}

	if(opts->debug)
		fprintf(stderr, "DEBUG: [%d] Command execution completed.\n", ti);
	
error:
	if(cmdstr)
		free(cmdstr);
	
error2:
	shutdown(ctrls, 2);
	shutdown(datas, 2);

	closesocket(ctrls);
	closesocket(datas);

	CloseHandle(pi.hProcess);

	return 0;
}

static void listenLoop(Options *opts)
{
	WSADATA		wd;
	SOCKADDR_IN	sin;
	struct servent	*serv;
	struct linger	lin;
	WORD		wsVersion;
	SOCKET		main_s, new_s;
	BOOL		on = TRUE;
	int			opt = SO_SYNCHRONOUS_NONALERT;

	// Initialise WinSock
	
	if(opts->debug)
		fprintf(stderr, "DEBUG: Initialising WinSock...\n");

	wsVersion = MAKEWORD(1, 1);

	if(WSAStartup(wsVersion, &wd) != 0) {
		fprintf(stderr, "FATAL ERROR: Can't initialise WinSock DLL\n");
		exit(1);
	}
	
	// Open a listening socket
	
	if(opts->debug)
		fprintf(stderr, "DEBUG: Setting up a incoming connection socket...\n");

	if(setsockopt(INVALID_SOCKET, SOL_SOCKET, SO_OPENTYPE, (char *)&opt, sizeof(opt)) == SOCKET_ERROR) {
		fprintf(stderr, "FATAL ERROR: Can't set SO_OPENTYPE global option.\n");
		exit(1);
	}

	main_s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	
	// Have it re-use the socket...
	if(setsockopt(main_s, SOL_SOCKET, SO_REUSEADDR, (char *)&on, sizeof(on)) == SOCKET_ERROR) {
		fprintf(stderr, "WARNING: Can't set SO_REUSEADDR option on main socket.\n");
	}

	serv = getservbyname("cmd", NULL);

	sin.sin_family = AF_INET;
	sin.sin_addr.s_addr = INADDR_ANY;
	sin.sin_port = serv->s_port;

	if(bind(main_s, (SOCKADDR *)&sin, sizeof(sin)) == SOCKET_ERROR) {
		fprintf(stderr, "FATAL ERROR: Can't bind socket to port (%d)\n", ntohs(serv->s_port));
		exit(1);
	}

	if(listen(main_s, 5) == SOCKET_ERROR) {
		fprintf(stderr, "FATAL ERROR: Can't set socket to listening mode.\n");
		exit(1);
	}

	// Set options
	
	lin.l_onoff = 1;
	lin.l_linger = 60;		// Magic

	if(setsockopt(main_s, SOL_SOCKET, SO_LINGER, (char *)&lin, sizeof(lin)) == SOCKET_ERROR) {
		fprintf(stderr, "WARNING: Can't set SO_LINGER option on main socket.\n");
	}
	
	if(opts->debug)
		fprintf(stderr, "DEBUG: Setup done. Waiting for incoming connections...\n");
	else
		fprintf(stderr, "INFO: Waiting for incoming connections...\n");
	
	// Start accepting incoming connections...

	for(;;) {
		SECURITY_ATTRIBUTES		sa;
		DWORD					threadID;
		CmdData					cd;
		int						size = sizeof(sin);
		
		new_s = accept(main_s, (SOCKADDR *)&sin, &size);
		if(new_s == INVALID_SOCKET) {
			fprintf(stderr, "ERROR: accept() failed.\n");
			continue;
		}

		// Kick off a thread that handles this socket
		
		sa.nLength = sizeof(sa);
		sa.lpSecurityDescriptor = NULL;
		sa.bInheritHandle = TRUE;
		
		cd.s = new_s;
		cd.opts = opts;

		if(opts->debug)
			fprintf(stderr, "DEBUG: Starting a command handling thread...\n");

		if(_beginthreadex(&sa, 0, cmdThread, (LPVOID)&cd, 0, &threadID) == 0) {
			fprintf(stderr, "ERROR: Can't create command thread.\n");
			continue;
		}

		// Make sure the thread gets some slice of time...
		Sleep(0);
	}

}

static void showUsage(void)
{
	fprintf(stderr, "Usage:\nrshd [-a][-d][-n]\n\n");
	fprintf(stderr, "  -a     Check if incoming connection is within domain.\n");
	fprintf(stderr, "  -d     Run in debug mode.\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "The configuration file should be called 'rshd.cfg' and be placed in\n");
	fprintf(stderr, "the same directory as the executable. It has only two sections:\n");
	fprintf(stderr, "[AllowIP] and [Path Subst].\n");
	fprintf(stderr, "The [AllowIP] section contains a EOL separated list of IP numbers with\n");
	fprintf(stderr, "a mask that are allowed to connect to the rsh daemon. For example:\n");
	fprintf(stderr, "[AllowIP]\n");
	fprintf(stderr, "192.168.1.1/32          # Only allows one machine from this subnet\n");
	fprintf(stderr, "192.168.20.0/24         # Let's through a whole Class-C subnet\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "If this section is empty, all IP connections are let through.\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "The [Path Subst] section is a bit more involved. It implements a \n");
	fprintf(stderr, "string substitution to be performed on the command string.\n");
	fprintf(stderr, "For example:\n");
	fprintf(stderr, "[Path Subst]\n");
	fprintf(stderr, "/C:/D:/                 # all references to C: will be changed to D:\n");
	fprintf(stderr, "%%/server/%%S:/%%          # Changes all '/server/' refs to 'S:/'.\n");
	fprintf(stderr, "Note. You can use any string delimiter character instead of '/'.\n");

	exit(1);
}

int main(int argc, char **argv)
{
	Options		opts;
	
	ZeroMemory(&opts, sizeof(opts));

	// Skip over the program's name
	argc--;
	argv++;
	
	while(argc) {
		if(stricmp(*argv, "-a") == 0)
			opts.checkAll = TRUE;
		else 
		if(stricmp(*argv, "-d") == 0)
			opts.debug = TRUE;
		else
			showUsage();
		argc--;
		argv++;
	}
		
	if(!CFG_read(&opts.cfg)) {
		return 1;
	}

	fprintf(stderr, "rshd.exe - (C) Pison 1998 - 1999\n");
	fprintf(stderr, "================================\n");
	listenLoop(&opts);

	return 0;
}
